import processing.core.*; import simpleML.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; import javax.sound.midi.*; import javax.sound.midi.spi.*; import javax.sound.sampled.*; import javax.sound.sampled.spi.*; import java.util.regex.*; import javax.xml.parsers.*; import javax.xml.transform.*; import javax.xml.transform.dom.*; import javax.xml.transform.sax.*; import javax.xml.transform.stream.*; import org.xml.sax.*; import org.xml.sax.ext.*; import org.xml.sax.helpers.*; public class Zoe_fraade_final_icm extends PApplet {

//global variables

//declare an array of MapItem objects
MapItem[] visualization;
MapItem[] overlookedVisualization;

//Create the background
Scenery someScenery;

//create the connection to the database, and copies of info
DatabaseHandler DBInfo;

public void setup(){

  background(255);
  size(800,550);

  //Create an XML Request object.  The rest of the code for this is in the DatabaseHandler Class file.
  xmlRequest = new XMLRequest(this, "http://www.binaryspark.com/reader/articleHarvester.php" );
  
  //Create the Scenery 
  someScenery=new Scenery(); 

  DBInfo = new DatabaseHandler();   //This will actually pass the url of the database

  visualization = new MapItem[DBInfo.Headline.length];  // this creates an array the length of what is curently in the database, one item
  
  overlookedVisualization = new MapItem[DBInfo.Headline.length];  // this creates an array the length of what is curently in the database, one item

  //filling the array of MapItems.  In the future we'll want this to be in Draw.

  for (int i=0; i < visualization.length; i++){
    visualization[i]=new MapItem(DBInfo.Headline[i], DBInfo.Blurb[i], DBInfo.City[i], DBInfo.Country[i], DBInfo.Lat[i], DBInfo.Long[i], false, 0);
  }
  
  for (int i=0; i < overlookedVisualization.length; i++){
    overlookedVisualization[i]=new MapItem(DBInfo.Headline[i], DBInfo.Blurb[i], DBInfo.City[i], DBInfo.Country[i], DBInfo.Lat[i], DBInfo.Long[i], true, 0);
  }

}

public void draw() {
  
  //display the items on the map items
someScenery.display ();

  someScenery.displayMapItems();
  
 // someScenery.displayCountryMissed();

}



public void mouseClicked() {
  
    someScenery.mouseLogicMap (mouseX, mouseY);
  
}
 



//this class exists only to deal with the database.  I may not use it in the final version.

 
 //Declare the XML request as a global.  This is not part of the Database Handler class
 XMLRequest xmlRequest;

class DatabaseHandler  {

  //global class variables

  //String[]   URL={
    //    "http://www.nytimes.com/2008/10/23/business/economy/23rating.html?_r=1&partner=rssnyt&emc=rss&oref=slogin" , "http://www.nytimes.com/2008/10/23/nyregion/23fiction.html?partner=rssnyt&emc=rss" , "http://www.nytimes.com/2008/10/23/world/asia/23afghan.html?partner=rssnyt&emc=rss", "http://www.nytimes.com/2008/10/22/world/europe/22italy.html?partner=rssnyt&emc=rss" , "http://www.nytimes.com/2008/10/22/world/asia/22indiamoon.html?partner=rssnyt&emc=rss"       };
   
   /*
    String[]    Headline= {
        "Credit Rating Agency Heads Grilled by Lawmakers", "Urban Fiction Goes From Streets to Public Libraries", "Airstrike Kills 9 Afghan Soldiers", "Italy\u2019s Crisis Has Premier Riding High" , "India Launches Unmanned Orbiter to Moon"       };
   String[]     Blurb = {
        "Members of Congress leveled sharp criticism at what they called egregious lapses at the credit-rating agencies.", "Many libraries are embracing a sometimes controversial genre of \u201cstreet lit\u201d in an effort to attract new readers.", "The United States-led coalition said that the attack may have been a case of mistaken identity on both sides." , "Italy\u2019s prime minister, Silvio Berlusconi, is getting a boost to his political fortunes from the economic crisis." , "The mission is scheduled to last for two years, in which the craft will search the lunar surface for natural resources."       };
    String[]    City = {
        "Washington DC", "New York City", "Kabul" , "Rome" , "New Delhi"      };
     String[]   Country = {
        "United States","United States","Afghanistan", "Italy" , "India"      };
    Float[]    Lat = {
        38.87, 40.75, 34.51 , 41.89 , 28.63       };
     Float[] Long = {
        -77.03, -73.98, 69.19 , 12.48 , 77.22       };
        
  String[]  OverlookedHeadline= {"temp"};
  String[]  OverlookedBlurb={"temp"}; 
  String[]  OverlookedCity = { "Loading"      };  
  String[]  OverlookedCountry ={"please wait"}; 
  float[]  OverlookedLat ={-190.0}; 
  float[]  OverlookedLong={-190.0}; 

*/
  String[] CountryMissed;
  String[] URLMissed;


  String[]  Headline= {"temp"};
  String[]  Blurb={"temp"}; 
  String[]  City = { "Loading"      };  
  String[]  Country ={"please wait"}; 
  float[]  Lat ={-190.0f}; 
  float[]  Long={-190.0f}; 
 boolean[]  IsOverlooked={false}; 
  
 
  //Constructor
  DatabaseHandler () {   //This actually will receive the url of the database in the form of URL = new String[5] ;


      //some fake information for the countries missed.
      CountryMissed = new String[5];
      for(int u=0; u<5; u++)  {  //This is actually going to be the number of rows
         CountryMissed [u] =str(random(10));  //just giving it some content
       }
      
       
       
      //read in the  with the database info
      xmlRequest.makeRequest();
     
      //Now the program waits for the returning information to trigger netEvent
  }

public void recordDB (String[] tempCity, String[] tempCountry, String[] tempHeadline, String[] tempBlurb, float[] tempLat, float[] tempLong, boolean[] tempIsOverlooked) {
  
  //take the variables you assigned and make them universally usable
    City[0] = tempCity[0];  //cover up the initial item
    Country[0] = tempCountry[0];  //cover up the initial item
    Headline[0] = tempHeadline[0];  //cover up the initial item
    Blurb[0] = tempBlurb[0];  //cover up the initial item
    Lat[0] = tempLat[0];  //cover up the initial item
    Long[0] = tempLong[0];  //cover up the initial item
    IsOverlooked[0] = tempIsOverlooked[0];  //cover up the initial item
    
 
    
    for (int i=1; i< tempCity.length; i++) {  //fill in the rest of the items
      City = append(City, tempCity[i]); 
     // println ("cities:" + City.length);
  }
        
    for (int i=1; i< tempCountry.length; i++) {  //fill in the rest of the items
      Country = append(Country, tempCountry[i]); 
      // println ("Countries:" + Country.length);
  }
       
    for (int i=1; i< tempHeadline.length; i++) {  //fill in the rest of the items
      Headline = append(Headline, tempHeadline[i]); 
       //println ("Headlines:" + Headline.length);
  }
  
     
    for (int i=1; i< tempBlurb.length; i++) {  //fill in the rest of the items
      Blurb = append(Blurb, tempBlurb[i]); 
       //println ("blurb:" + Blurb.length);
  }
      
    for (int i=1; i< tempLat.length; i++) {  //fill in the rest of the items
       
      Lat = append(Lat, tempLat[i]); 
       //println ("Lat:" + Lat.length);
  }
    
    for (int i=1; i< tempLong.length; i++) {  //fill in the rest of the items
      Long = append(Long, tempLong[i]); 
      // println ("Long:" + Long.length);
      
    }
    
     for (int i=1; i< tempIsOverlooked.length; i++) {  //fill in the rest of the items
      IsOverlooked = (boolean[])append(IsOverlooked, tempIsOverlooked[i]); 
      // println ("IsOverlooked:" + IsOverlooked.length);
      
    }
  
  fillArticles();
  
  }//close function
 
}//close class

//note, netEvent is not technically part of the DatabaseHandler Class.
public void netEvent(XMLRequest xmlRequest) {
  
  println ("netEvent");
  
    //get the all the headlines
  String [] localCity = xmlRequest.getElementArray( "city" );
  //println(xmlRequest.getElementArray( "city" ));  // Print message
        
  String [] localCountry = xmlRequest.getElementArray( "country" );
  //println("Request completed!" + Headlinetest.length);  // Print message
      
  String [] localHeadline = xmlRequest.getElementArray( "headline" );
  //println("Request completed!" + Headlinetest.length);  // Print message
    
  String [] localBlurb = xmlRequest.getElementArray( "blurb" );
  //println("Request completed!" + Headlinetest.length);  // Print message
      
    float [] localLat = PApplet.parseFloat(xmlRequest.getElementArray( "lat" ));
  //println("Request completed!" + Headlinetest.length);  // Print message
  
    float [] localLong = PApplet.parseFloat(xmlRequest.getElementArray( "long" ));
  //println("Request completed!" + Headlinetest.length);  // Print message
  
    boolean [] localIsOverlooked = PApplet.parseBoolean(xmlRequest.getElementArray( "isoverlooked" ));
    
    
      //for (int i = 0; i < LocalIsOverlooked.length; i++ ) {
        
        //LocalIsOverlooked[i] = boolean(tempLocalIsOverlooked[i]);
        
          //println(localIsOverlooked[i]);
      //}
  
 DBInfo.recordDB(localCity, localCountry, localHeadline, localBlurb, localLat, localLong, localIsOverlooked);
  
  
  //testing purposes only

  
}


//also not part of the Database Handler class, this is global but placed here for ease of finding
public void fillArticles(){
  
 
  
  //Create new articles out of the new information
  //put them in the visualization array - replace the first item and append the others
  
   //these keep track of where we are in the arrays of MapItemObjects when we're loading them up
  int NYTCounter = 0;  
  int OverlookedCounter = 0;
  
 
 for (int i=0; i < DBInfo.Headline.length; i++){
   
   if (DBInfo.IsOverlooked[i] == false) {
     
     // println ("DBInfo is false");
     
     if (NYTCounter == 0){  //if this is the first time we're hitting a NYTimes article
      //println ("And this is the first NYTimes Article");
   
       MapItem tempMapItem = new MapItem(DBInfo.Headline[0], DBInfo.Blurb[0], DBInfo.City[0], DBInfo.Country[0], DBInfo.Lat[0], DBInfo.Long[0], false, NYTCounter);
        visualization[0] = tempMapItem;
        
        NYTCounter++;
 
       }  //end if nytcounter==0
   
   else {
     
        MapItem tempMapItem = new MapItem(DBInfo.Headline[i], DBInfo.Blurb[i], DBInfo.City[i], DBInfo.Country[i], DBInfo.Lat[i], DBInfo.Long[i], false, NYTCounter);
    
        visualization = (MapItem[])append(visualization, tempMapItem);
        
        NYTCounter++;
        
      }//end else
 
     
   }//end if this is not an overlooked article
   
   else {    //if isOverlooked=true
   
   //println ("DBInfo is true");
   
     if (OverlookedCounter==0){  //if this is the first time we're hitting an Overlooked article
        
        //println ("And this is the first Overlooked Article");
   
       MapItem tempMapItem = new MapItem(DBInfo.Headline[i], DBInfo.Blurb[i], DBInfo.City[i], DBInfo.Country[i], DBInfo.Lat[i], DBInfo.Long[i], true, OverlookedCounter);
        overlookedVisualization[0] = tempMapItem;
        
        OverlookedCounter++;
 
       }  //end if nytcounter==0
   
     else {  //if overlookedcounter is not 0
     
        MapItem tempMapItem = new MapItem(DBInfo.Headline[i], DBInfo.Blurb[i], DBInfo.City[i], DBInfo.Country[i], DBInfo.Lat[i], DBInfo.Long[i], true, OverlookedCounter);
    
        overlookedVisualization = (MapItem[])append(overlookedVisualization, tempMapItem);
        
        OverlookedCounter++;
        
      }//end else
 
   
   }//end else
   
 } //end for loop
   
  
}//end function
//this class is for an object.  An array of them will be created each time RSSGrabber is run.
//Each object knows its url, city, state, lat, and long.  It may eventually also know its sensative area for mousepressed

class MapItem  {
  //global class variables:

  //String URL;
  String Headline;
  String Blurb;
  String City;
  String Country;
  float Lat;
  float Long;
  boolean isOverlooked;

  int xlocal;  //the location of the circle where the location exists
  int ylocal;

  int ylocalLine;  //the lenght of th line between the point on the map and the article
  
  String cityCountry;
  
 
  int ytext;  //the y location of where the cityCountry exists at any given time.  
  

  int unselected = color(6,10,191);
  int selected = color(0, 155,  224);
  boolean isSelected = false;

  PFont Arial;
  PFont ArialSmall;
  PFont ArialMedium;
  PFont ArialMediumItalic;

  float distance;  //the amount of space between the map visualization and the article visualization
  float distanceLeft; //the amount of line left to draw

  int articleX;  //location for article at the bottom of the page
  int articleY;
  
  

  //Constructor

  MapItem (String tempHeadline, String tempBlurb, String tempCity, String tempCountry, float tempLat, float tempLong, boolean tempIsOverlooked, int tempPosition)  {

    //this is where the constructor will hit the database and collect the info it needs, and dump it in the following array:

    //URL=tempURL;
    Headline=tempHeadline;
    Blurb=tempBlurb;
    City=tempCity;
    Country=tempCountry;
    Lat=tempLat;
    Long=tempLong; 
    isOverlooked = tempIsOverlooked;

    xlocal = PApplet.parseInt(map(Long, -180, 180, 0, 588));
    ylocal = PApplet.parseInt(map(Lat-32, 90, -90, 0, 349));  //31 because this map does not cover the arctic
    
    ytext = tempPosition * 15;  //this gives us the number of pixels down it appears at. Each item scoots south fifteen pixels

    ylocalLine = ylocal;
    
    cityCountry = City + ", " + Country;  //A string with both City and Country in it

    smooth();

    Arial = loadFont("ArialMT-20.vlw");
    ArialSmall = loadFont("ArialMT-10.vlw");
    ArialMedium = loadFont ("ArialMT-12.vlw");
    ArialMediumItalic = loadFont ("Arial-ItalicMT-12.vlw");

    articleX=30;
    articleY=380;
    
    
    if (isOverlooked) {
      
      //println ("This is an overlooked item");
      
      unselected = color(21, 142, 26);
      selected = color(70, 203, 75);
    }

  }

  public void display()  {

    //check and set the dot color

    smooth();

    if (isSelected) {

      fill(selected);    
    }

    else{
      fill(unselected);
    }

    //create the dot on the map
    ellipse(xlocal, ylocal, 10, 10);


    textFont(ArialSmall, 10); 
    
    if ((!isOverlooked)&& (ytext < 190) && (ytext >= 0)) {
      
        //give us the text names of the countries
        
        text(cityCountry, 610, 63 + ytext);  
        
        //println (ytext);
    
    }
    
    else if ((isOverlooked) && (ytext <190) && (ytext >=0))        {
      
      text(cityCountry, 610, 335 + ytext);  
      
    }

    //create the graphic items particula for items that are selected
    if (isSelected) { 

      stroke(selected);
      strokeWeight(3);

      line (xlocal , ylocal+3, xlocal, ylocalLine);

      ylocalLine=constrain(ylocalLine+6, 0, 380);

      if (ylocalLine >=articleY) {

        displayArticle();

      }

      noStroke(); 
      fill(255);
      ellipse(xlocal, ylocal, 6, 6);

    }

  }

  public void displayArticle() { 

    //make the bckground rectangle

    fill(255, 200);
    stroke(selected);
    strokeWeight(3);
    rect (articleX, articleY, 530, 140);

    fill (selected);
    noStroke();

    textFont(Arial, 20); 
    text(Headline, articleX+20, articleY+25, 450, 200);
    
    
    textFont(ArialSmall, 10); 
    text(cityCountry, articleX+20, articleY+80);
    
    fill (0);
    textFont(ArialMedium, 12); 
    text(Blurb, articleX+20, articleY+85, 450, 250);
    
    //fill (160,160,160);
    //textFont (ArialMediumItalic);
    //text(URL, articleX+20, articleY+110);

  }

}




class Scenery  {

  PFont Arial;
  PFont ArialSmall;

  int lastSelected;

  boolean firstTimeThrough;
  
  PImage map;
  PImage nyt;
  
  int nytcounter;
  
  String NYTActiveTriangle;
  String OverlookedActiveTriangle;


  Scenery ()   {

    smooth();

    Arial = loadFont("ArialMT-20.vlw");
    ArialSmall = loadFont("ArialMT-10.vlw");

    map = loadImage("map.gif");
    nyt = loadImage("nyt.gif");

    lastSelected = 0;  
    
    nytcounter = 0;
    
    NYTActiveTriangle = "down";   //says which triangle is highlighted at any given moment - up, down, or both
    OverlookedActiveTriangle = "down";   //says which triangle is highlighted at any given moment

  }

  public void display() {
    fill (255);  //white background for the top
    rect(0, 352, width, height);

    fill(240);  //grey right-side
    noStroke();
    rect(595, 3, 202, height-3);
    
    noTint();
    image(map, 3, 3);


    fill(88);
    textFont(Arial, 20); 
    text("recently covered", 645, 25);
    
    text("recently missed", 652, 293);
    
    //display scroll triangles
    
    triangle(630, 32, 620, 47, 640, 47);    //nyt top
    
     triangle(630, 267, 620, 252, 640, 252);  //nyt bottom
    
    triangle(630, 302, 620, 317, 640, 317);   //overlooked top
     
    triangle(630, 537, 620, 522, 640, 522);  //overlooked bottom
    
    
    
    
    //display rolling text at bottom
    tint(255, 255, 255, 30); 
    image(nyt, 0-nytcounter, visualization[0].articleY-28);  //used 0 for no particular reason other than there probably will always be one

    image(nyt, 0+2228-nytcounter, visualization[0].articleY-28);  //used 0 for no particular reason other than there probably will always be one

    if (nytcounter>=2228) 
    { nytcounter=-1;
    }
    nytcounter=nytcounter+1;
    
  }

  public void displayMapItems(){

    //int w=0;  //this is the number of pixels down the name needs to be

    for (int i=0; i<visualization.length; i++){
      smooth();

      visualization[i].display();
      //println(i);

      //w=w+15;  //incrimenting w further down
    }
    
     //w=0;  // go back to the top of the page
    for (int i=0; i<overlookedVisualization.length; i++){
      smooth();

      overlookedVisualization[i].display();
      //println(i);

      //w=w+15;  //incrimenting w further down
    }

  }


  public void mouseLogicMap (int mouseX, int mouseY) {

    if (mouseX < 600) {

      println ("test");

      //check if something has been clicked in visualization on the map      
      for (int i=0; i< visualization.length ; i++){

        if (((mouseX >(visualization[i].xlocal)-10)&&(mouseX <(visualization[i].xlocal)+10)) && ((mouseY >(visualization[i].ylocal)-10)&&(mouseY <(visualization[i].ylocal)+10)))  
        {     
          
          if (lastSelected <= overlookedVisualization.length) {
            
            overlookedVisualization[lastSelected].isSelected = false;   //turn off the color for the last selected item if it was in overlooked
            overlookedVisualization[lastSelected].ylocalLine = overlookedVisualization[lastSelected].ylocal;  
        }
          
           if (lastSelected <= visualization.length) {
            
            visualization[lastSelected].isSelected = false;   //turn off the color for the last selected item if it was in visualization
            visualization[lastSelected].ylocalLine = visualization[lastSelected].ylocal;  
        }


          visualization[i].isSelected=true;  //i'm putting this here instead of mapItem for modularity

          lastSelected = i;

          //visualization[i].displayArticle();

        } //close if

      } //close for
      
      //check if something has been clicked in overlookedVisualization on the map
      
      for (int i=0; i < overlookedVisualization.length ; i++){

        if (((mouseX >(overlookedVisualization[i].xlocal)-10)&&(mouseX <(overlookedVisualization[i].xlocal)+10)) && ((mouseY >(overlookedVisualization[i].ylocal)-10)&&(mouseY <(overlookedVisualization[i].ylocal)+10)))  
        {     
          
          if (lastSelected <= overlookedVisualization.length) {
            
            overlookedVisualization[lastSelected].isSelected = false;   //turn off the color for the last selected item if it was in overlooked
            overlookedVisualization[lastSelected].ylocalLine = overlookedVisualization[lastSelected].ylocal;  
        }
          
           if (lastSelected <= visualization.length) {
            
            visualization[lastSelected].isSelected = false;   //turn off the color for the last selected item if it was in visualization
            visualization[lastSelected].ylocalLine = visualization[lastSelected].ylocal;  
        }
          

          overlookedVisualization[i].isSelected=true;  //i'm putting this here instead of mapItem for modularity

          lastSelected = i;

          //visualization[i].displayArticle();

        } //close if

      } //close for

    }//close if the click is on the map
    
    
    else if ((mouseY > 47) && (mouseY <252)) {  //they're clicking somewhere in visualization
    
        float tempMouseY = PApplet.parseFloat(mouseY);
        
        float clickIndex = ((tempMouseY-63)/15)*15;
        
        println (clickIndex);
        
           for (int i=0; i < visualization.length ; i++){
             
             if ((clickIndex >= (visualization[i].ytext)-10)&&(clickIndex <= (visualization[i].ytext+5))) {
               
               println ("city:" + visualization[i].City);
               
               
               ///start process:
               if (lastSelected <= overlookedVisualization.length) {
            
            overlookedVisualization[lastSelected].isSelected = false;   //turn off the color for the last selected item if it was in overlooked
            overlookedVisualization[lastSelected].ylocalLine = overlookedVisualization[lastSelected].ylocal;  
        }
          
           if (lastSelected <= visualization.length) {
            
            visualization[lastSelected].isSelected = false;   //turn off the color for the last selected item if it was in visualization
            visualization[lastSelected].ylocalLine = visualization[lastSelected].ylocal;  
        }
          

          visualization[i].isSelected=true;  //i'm putting this here instead of mapItem for modularity

          lastSelected = i;
              
               
             }//end if
             
           }//end for
    
  }//end elseif
  
   else if ((mouseY > 317) && (mouseY <522)) {  //they're clicking somewhere in visualization
    
        float tempMouseY = PApplet.parseFloat(mouseY);
        
        float clickIndex = ((tempMouseY-335)/15)*15;
        
        println (clickIndex);
        
           for (int i=0; i < overlookedVisualization.length ; i++){
             
             if ((clickIndex >= (overlookedVisualization[i].ytext)-10)&&(clickIndex <= (overlookedVisualization[i].ytext+5))) {
               
               println ("city:" + overlookedVisualization[i].City);
               
               if (lastSelected <= overlookedVisualization.length) {
            
            overlookedVisualization[lastSelected].isSelected = false;   //turn off the color for the last selected item if it was in overlooked
            overlookedVisualization[lastSelected].ylocalLine = overlookedVisualization[lastSelected].ylocal;  
        }
          
           if (lastSelected <= visualization.length) {
            
            visualization[lastSelected].isSelected = false;   //turn off the color for the last selected item if it was in visualization
            visualization[lastSelected].ylocalLine = visualization[lastSelected].ylocal;  
        }
          

          overlookedVisualization[i].isSelected=true;  //i'm putting this here instead of mapItem for modularity

          lastSelected = i;

             }//end if
             
           }//end for
    
     }//end elseif
    //check for the triangles to see if we should move things up or down

      
      if ((mouseX <= 640) && (mouseX >= 620) && (mouseY >= 32) && (mouseY <= 47))  //the first triangle has been triggered
        {  
          
                for (int i=0; i< visualization.length ; i++){
                    
                  visualization[i].ytext = visualization[i].ytext -15;
                  
                }  //end for
          
        }//end if first triangle
        
      if ((mouseX <= 640) && (mouseX >= 620) && (mouseY >= 252) && (mouseY <= 267))  //the second triangle has been triggered
        {  
          
                for (int i=0; i< visualization.length ; i++){
                    
                  visualization[i].ytext = visualization[i].ytext +15;
                  
                }  //end for
        }//close second if
        
       if ((mouseX <= 640) && (mouseX >= 620) && (mouseY >= 302) && (mouseY <= 317))  //the third triangle has been triggered
        {  
          
                for (int i=0; i< overlookedVisualization.length ; i++){
                    
                  overlookedVisualization[i].ytext = overlookedVisualization[i].ytext -15;
                  
                }  //end for
          
        }//end if third triangle
        
         if ((mouseX <= 640) && (mouseX >= 620) && (mouseY <= 537) && (mouseY >= 522))  //the fourth triangle has been triggered
        {  
          
                for (int i=0; i< visualization.length ; i++){
                    
                  overlookedVisualization[i].ytext = overlookedVisualization[i].ytext +15;
                  
                }  //end for
        }//close fourth if
        
      //int clickIndex = ((mouseY-35)/15);  

      //visualization[lastSelected].isSelected = false;

      //visualization[lastSelected].ylocalLine = visualization[lastSelected].ylocal;

      //visualization[clickIndex].isSelected=true;  //i'm putting this here instead of mapItem for modularity

      //lastSelected = clickIndex;

   

  }   //close mouselogicmap

}  //close class

  static public void main(String args[]) {     PApplet.main(new String[] { "Zoe_fraade_final_icm" });  }}